/* -*- Mode: C++; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 2 -*-
 *   Gnome Apt frontend
 *
 *   Copyright (C) 1998 Havoc Pennington <hp@pobox.com>
 *
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License as 
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 */

#ifndef GNOME_APT_DETAILS_H
#define GNOME_APT_DETAILS_H

#include "gnome-apt.h"
#include "infopanes.h"

class Details : public GAptCacheFile::CacheView
{
public:
  Details();
  virtual ~Details();

  void set_selection(pkgCache::Package* p) { info_.set_selection(p); }
  void set_cache    (GAptCache* cache) { info_.set_cache(cache); }

  void show();
  void hide();

private:
  GAptInfoPanes info_;

  GtkWidget* window_;

};

#endif
